Imports System.Web.Services

<WebService(Namespace:="http://nagios-wsc/")> _
Public Class Service1
    Inherits System.Web.Services.WebService

    Dim wsc_version As String = "nagios-wsc v1.0 Release"
    Dim username As String = ""
    Dim password As String = ""
    Dim debug_flag = False

#Region " Web Services Designer Generated Code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Web Services Designer.
        InitializeComponent()

        'Add your own initialization code after the InitializeComponent() call

    End Sub

    'Required by the Web Services Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Web Services Designer
    'It can be modified using the Web Services Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        components = New System.ComponentModel.Container()
    End Sub

    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        'CODEGEN: This procedure is required by the Web Services Designer
        'Do not modify it using the code editor.
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

#End Region

    <WebMethod(Description:="This method checks a single, local disk of a remote server and compares to the threshold value, supplied in megabytes")> Public Function disk(ByVal server As String, ByVal param As String) As String
        ' parameters:
        ' server = name of remote server to query
        ' param = drive,warning/critical level to use - in MEGABYTES

        Dim oq As System.Management.ObjectQuery
        Dim mos As System.Management.ManagementObjectSearcher
        Dim options As New System.Management.ConnectionOptions()
        Dim res_str As String = wsc_version

        server = check_debug(server)

        get_auth(server, username, password)
        options.Username = username
        options.Password = password
        Dim obj
        Dim free As Double
        Dim size As Double

        Dim param_temp As String = param + ",-1,-1"
        Dim myarr() As String = param_temp.Split(",")
        Dim disk_to_check As String = myarr(0).ToString
        If disk_to_check = "" Then disk_to_check = "C"
        Dim warning_val As Long = 1024 * 1024 ' default 1MB
        If myarr(1) <> -1 Then
            warning_val = Val(myarr(1)) * 1024 * 1024
        End If
        Dim critical_val As Long = warning_val / 2
        If myarr(2) <> -1 Then
            critical_val = Val(myarr(2)) * 1024 * 1024
        End If

        If debug_flag Then
            res_str = res_str & "Server: '" & server & "'....."
            res_str = res_str & "Param value passed: '" & param & "'....."
            res_str = res_str & "Disk to check: '" & disk_to_check & "'....."
            res_str = res_str & "warning_value: '" & warning_val & "'(bytes)....."
            res_str = res_str & "critical_value: '" & critical_val & "'(bytes)....."
            res_str = res_str & "WMI username: '" & username & "'.....Notes:"

            If param = "" Then
                res_str = res_str & "Disk defaulted to C drive....."
            End If
            If myarr(1) = -1 Then
                res_str = res_str & "Warning value defaulted to 1MB....."
            End If
            If myarr(2) = -1 Then
                res_str = res_str & "Critical value defaulted (to half of warning value)....."
            End If
            Return res_str
        Else
            res_str = ""
        End If

        Dim scope As New System.Management.ManagementScope("\\" & server & "\root\cimv2:Win32_LogicalDisk", options)
        Try
            scope.Connect()

        Catch e As System.Management.ManagementException

            If e.ErrorCode = Management.ManagementStatus.LocalCredentials Then
                ' catch for when checking local machine - credentials not required
                scope = Nothing
                scope = New System.Management.ManagementScope("\\" & server & "\root\cimv2")
            Else
                Return wsc_version & "Result: Connect error = " & e.Message
            End If
        End Try

        oq = New System.Management.ObjectQuery("Select * from Win32_LogicalDisk where drivetype = 3 and deviceid = '" & disk_to_check & ":'")

        mos = New System.Management.ManagementObjectSearcher(scope, oq)
        '   Dim output As String = ""
        Dim disk_str As String = ""
        Dim low_space As Boolean = False
        Dim very_low As Boolean = False
        '  Dim i_threshold As Long
        '  i_threshold = Val(param) * 1024 * 1024 ' convert megabytes to bytes
        For Each obj In mos.Get()
            If disk_str <> "" Then disk_str = disk_str & "<br>"
            free = System.Convert.ToDouble(obj("freespace"))
            If free < warning_val Then low_space = True
            If free < critical_val Then very_low = True
            size = System.Convert.ToDouble(obj("size"))
            If free < warning_val Then disk_str = disk_str & "<b>"
            disk_str = disk_str & obj("DeviceID") & get_gb(free) & "/" & get_gb(size) & " (" & Format(((100 * free) / size), "standard") & "% free)"
            If free < warning_val Then disk_str = disk_str & "</b>"
        Next

        If very_low Then
            Return wsc_version & "Result: Disk Critical<br>" + disk_str
        Else
            If low_space Then
                Return wsc_version & "Result: Disk Warning<br>" + disk_str
            Else
                Return wsc_version & "Result: Disk Okay<br>" + disk_str
            End If
        End If

    End Function

    <WebMethod(Description:="This method checks all local disks of a remote server and compares to the threshold value, supplied in megabytes")> Public Function disks(ByVal server As String, ByVal param As String) As String
        ' parameters:
        ' server = name of remote server to query
        ' param = warning/critical level to use - in MEGABYTES

        Dim oq As System.Management.ObjectQuery
        Dim mos As System.Management.ManagementObjectSearcher
        Dim options As New System.Management.ConnectionOptions()
        Dim res_str As String = wsc_version

        server = check_debug(server)

        get_auth(server, username, password)
        options.Username = username
        options.Password = password
        Dim obj
        Dim free As Double
        Dim size As Double

        Dim param_temp As String = param
        If param_temp = "" Then param_temp = "-1"
        Dim myarr() As String = param_temp.Split(",")
        Dim warning_val As Long = 1024L * 1024L
        If myarr(0) <> -1 Then
            warning_val = Val(myarr(0)) * 1024L * 1024L
        End If
        Dim critical_val As Long = warning_val / 2
        If myarr.GetUpperBound(0) = 1 Then  ' 2nd param not entered
            critical_val = Val(myarr(1)) * 1024L * 1024L
        End If
        If debug_flag Then
            res_str = res_str & "Server: '" & server & "'....."
            res_str = res_str & "Param value passed: '" & param & "'....."
            res_str = res_str & "warning_value: '" & warning_val & "'(bytes)....."
            res_str = res_str & "critical_value: '" & critical_val & "'(bytes)....."
            res_str = res_str & "WMI username: '" & username & "'.....Notes:"

            If myarr(0) = -1 Then
                res_str = res_str & "Warning value defaulted to 1MB....."
            End If
            If myarr.GetUpperBound(0) = 0 Then
                res_str = res_str & "Critical value defaulted (to half of warning value)....."
            End If
            Return res_str
        Else
            res_str = ""
        End If

        Dim scope As New System.Management.ManagementScope("\\" & server & "\root\cimv2:Win32_LogicalDisk", options)
        Try
            scope.Connect()

        Catch e As System.Management.ManagementException

            If e.ErrorCode = Management.ManagementStatus.LocalCredentials Then
                ' catch for when checking local machine - credentials not required
                scope = Nothing
                scope = New System.Management.ManagementScope("\\" & server & "\root\cimv2")
            Else
                Return wsc_version & "Result: Connect error = " & e.Message
            End If
        End Try

        oq = New System.Management.ObjectQuery("Select * from Win32_LogicalDisk where drivetype = 3")

        mos = New System.Management.ManagementObjectSearcher(scope, oq)
        '   Dim output As String = ""
        Dim disk_str As String = ""
        Dim low_space As Boolean = False
        Dim very_low As Boolean = False
        '  Dim i_threshold As Long
        '  i_threshold = Val(param) * 1024 * 1024 ' convert megabytes to bytes
        For Each obj In mos.Get()
            If disk_str <> "" Then disk_str = disk_str & "<br>"
            free = System.Convert.ToDouble(obj("freespace"))
            If free < warning_val Then low_space = True
            If free < critical_val Then very_low = True
            size = System.Convert.ToDouble(obj("size"))
            If free < warning_val Then disk_str = disk_str & "<b>"
            disk_str = disk_str & obj("DeviceID") & get_gb(free) & "/" & get_gb(size) & " (" & Format(((100 * free) / size), "standard") & "% free)"
            If free < warning_val Then disk_str = disk_str & "</b>"
        Next

        If very_low Then
            Return wsc_version & "Result: Disk(s) Critical<br>" + disk_str
        Else
            If low_space Then
                Return wsc_version & "Result: Disk(s) Warning<br>" + disk_str
            Else
                Return wsc_version & "Result: Disk(s) Okay<br>" + disk_str
            End If
        End If

    End Function

    <WebMethod(Description:="This method checks the uptime of a remote server and flags whether the server has been rebooted recently")> Public Function uptime(ByVal server As String, ByVal param As String) As String
        ' parameters:
        ' server = name of remote server to query
        ' param = warning/critical level to use - in Hours

        Dim oq As System.Management.ObjectQuery
        Dim mos As System.Management.ManagementObjectSearcher
        Dim options As New System.Management.ConnectionOptions()

        Dim res_str As String = wsc_version

        server = check_debug(server)

        get_auth(server, username, password)
        options.Username = username
        options.Password = password
        Dim obj As System.Management.ManagementObject

        Dim lastboot
        Dim curr_time As String
        Dim dtmlastbootuptime, dtmsystemuptime, dtmcurrtime
        Dim hours_up As Long
        Dim size As Double

        Dim param_temp As String = param
        If param_temp = "" Then param_temp = "-1"
        Dim myarr() As String = param_temp.Split(",")
        Dim warning_val As Long = Val(myarr(0))
        If warning_val = -1 Then warning_val = 24
        Dim critical_val As Long = warning_val / 2
        If myarr.GetUpperBound(0) = 1 Then
            critical_val = Val(myarr(1))
        End If

        If debug_flag Then
            res_str = res_str & "Server: '" & server & "'....."
            res_str = res_str & "Param value passed: '" & param & "'....."
            res_str = res_str & "warning_value: '" & warning_val & "'(hours)....."
            res_str = res_str & "critical_value: '" & critical_val & "'(hours)....."
            res_str = res_str & "WMI username: '" & username & "'.....Notes:"

            If myarr(0) = -1 Then
                res_str = res_str & "Warning value defaulted to 24....."
            End If
            If myarr.GetUpperBound(0) = 0 Then
                res_str = res_str & "Critical value defaulted (to half of warning value)....."
            End If
            Return res_str
        Else
            res_str = ""
        End If

        Dim scope As New System.Management.ManagementScope("\\" & server & "\root\cimv2:Win32_OperatingSystem", options)
        Try
            scope.Connect()
        Catch e As System.Management.ManagementException

            If e.ErrorCode = Management.ManagementStatus.LocalCredentials Then
                scope = Nothing
                scope = New System.Management.ManagementScope("\\" & server & "\root\cimv2")
            Else
                Return wsc_version & "Result: Connect error = " & e.Message
            End If
        End Try

        oq = New System.Management.ObjectQuery("Select * from Win32_OperatingSystem")

        mos = New System.Management.ManagementObjectSearcher(scope, oq)
        Dim low As Boolean = False
        Dim very_low As Boolean = False
        For Each obj In mos.Get()
            lastboot = obj("lastbootuptime")
            curr_time = obj("localdatetime")
            'hours_up = Val(Mid(curr_time, 1, 14)) - Val(Mid(lastboot, 1, 14))

            If lastboot = "" Then
                Return wsc_version & "Result: Uptime Okay<br>Server returned '" & lastboot & "' as last boot time"
            End If
            dtmlastbootuptime = WMIDateStringToDate(lastboot)
            dtmcurrtime = WMIDateStringToDate(curr_time)
            'dtmsystemuptime = DateDiff(DateInterval.Hour, dtmlastbootuptime, Now)
            dtmsystemuptime = DateDiff(DateInterval.Hour, dtmlastbootuptime, dtmcurrtime)
            'Return wsc_version & "Result: Uptime Okay<br>Server returned '" & dtmsystemuptime & "' as hours up"
            'hours_up = datediff(DateInterval.Hour,lastboot,now)
            If Val(dtmsystemuptime) < warning_val Then
                res_str = res_str & "<b>"
                low = True
            End If
            If Val(dtmsystemuptime) < critical_val Then very_low = True
            res_str = res_str & "Server up for " & dtmsystemuptime & " hours<br>Server last booted: " & Format(dtmlastbootuptime, "dd/MM/yyyy HH:mm:ss") & "<br>Current time on server: " & Format(dtmcurrtime, "dd/MM/yyyy HH:mm:ss")
            If low Then res_str = res_str & "</b>"
        Next

        If very_low Then
            Return wsc_version & "Result: Uptime Critical<br>" + res_str
        Else
            If low Then
                Return wsc_version & "Result: Uptime Warning<br>" + res_str
            Else
                Return wsc_version & "Result: Uptime Okay<br>" + res_str
            End If
        End If

    End Function

    <WebMethod(Description:="This method checks a list of services to see if any are not running")> Public Function services(ByVal server As String, ByVal param As String) As String
        ' parameters:
        ' server = name of remote server to query
        ' param = comma separated list of services to check

        Dim oq As System.Management.ObjectQuery
        Dim mos As System.Management.ManagementObjectSearcher
        Dim options As New System.Management.ConnectionOptions()
        Dim res_str As String = wsc_version

        server = check_debug(server)
        get_auth(server, username, password)
        options.Username = username
        options.Password = password

        Dim param_temp As String = param
        If param_temp = "" Then param_temp = "*"
        Dim where_str As String = ""
        Dim myarr() As String = param_temp.Split(",")
        Dim srv As String
        For Each srv In myarr
            If Trim(srv) = "*" Then
                where_str = ""
                Exit For
            End If
            If where_str <> "" Then where_str = where_str + " or "
            where_str = where_str + "name = '" + Trim(srv) + "'"
        Next
        If where_str = "" Then
            where_str = "Select * from Win32_Service"
        Else
            where_str = "Select * from Win32_Service where " + where_str
        End If

        If debug_flag Then
            res_str = res_str & "Server: '" & server & "'....."
            res_str = res_str & "Param value passed: '" & param & "'....."
            res_str = res_str & "Selection criteria: '" & where_str & "'....."
            res_str = res_str & "WMI username: '" & username & "'.....Notes:"

            If param = "" Then
                res_str = res_str & "All services returned....."
            End If
            Return res_str
        Else
            res_str = ""
        End If

        Dim obj
        Dim scope As New System.Management.ManagementScope("\\" & server & "\root\cimv2", options)
        Try
            scope.Connect()
        Catch e As System.Management.ManagementException

            If e.ErrorCode = Management.ManagementStatus.LocalCredentials Then
                ' catch for when checking local machine - credentials not required()
                scope = Nothing
                scope = New System.Management.ManagementScope("\\" & server & "\root\cimv2")
            Else
                Return wsc_version & "Result: Connect error = " & e.Message
            End If
        End Try

        oq = New System.Management.ObjectQuery(where_str)
        mos = New System.Management.ManagementObjectSearcher(scope, oq)

        Dim stopped As Boolean = False

        For Each obj In mos.Get()
            If res_str <> "" Then res_str = res_str & "<br>"
            If LCase(obj("state")) <> "running" Then
                stopped = True
                res_str = res_str + "<b>"
            End If
            res_str = res_str + obj("state") + "-" + obj("name")
            If LCase(obj("state")) <> "running" Then
                res_str = res_str + "</b>"
            End If

        Next

        If stopped Then
            Return wsc_version & "Result: Service(s) Critical<br>" + res_str
        Else
            Return wsc_version & "Result: Service(s) Okay<br>" + res_str

        End If

    End Function

    <WebMethod(Description:="This method checks the CPU utilisation")> Public Function cpu(ByVal server As String, ByVal param As String) As String
        ' parameters:
        ' server = name of remote server to query
        ' param = comma separated utilisation

        Dim oq As System.Management.ObjectQuery
        Dim mos As System.Management.ManagementObjectSearcher
        Dim options As New System.Management.ConnectionOptions()
        Dim res_str As String = ""

        server = check_debug(server)

        get_auth(server, username, password)
        options.Username = username
        options.Password = password

        Dim param_temp As String = param
        If param_temp = "" Then param_temp = "-1"

        Dim myarr() As String = param_temp.Split(",")
        Dim warning_val As Long = Val(myarr(0))
        Dim critical_val As Long = 60
        If warning_val = -1 Then
            warning_val = 20
        End If
        If myarr.GetUpperBound(0) = 1 Then
            critical_val = Val(myarr(1))
        End If

        If debug_flag Then
            res_str = res_str & "Server: '" & server & "'....."
            res_str = res_str & "Param value passed: '" & param & "'....."
            res_str = res_str & "warning_value: '" & warning_val & "'(hours)....."
            res_str = res_str & "critical_value: '" & critical_val & "'(hours)....."
            res_str = res_str & "WMI username: '" & username & "'.....Notes:"

            If param_temp = "-1" Then
                res_str = res_str & "Warning value defaulted to 20....."
            End If
            If myarr.GetUpperBound(0) = 0 Then
                res_str = res_str & "Critical value defaulted to 60....."
            End If
            Return res_str
        Else
            res_str = ""
        End If

        Dim query As String
        query = "Select * from Win32_Processor"

        Dim obj
        Dim scope As New System.Management.ManagementScope("\\" & server & "\root\cimv2", options)
        Try
            scope.Connect()
        Catch e As System.Management.ManagementException

            If e.ErrorCode = Management.ManagementStatus.LocalCredentials Then
                ' catch for when checking local machine - credentials not required()
                scope = Nothing
                scope = New System.Management.ManagementScope("\\" & server & "\root\cimv2")
            Else
                Return wsc_version & "Result: Connect error = " & e.Message
            End If
        End Try

        oq = New System.Management.ObjectQuery(query)
        mos = New System.Management.ManagementObjectSearcher(scope, oq)

        Dim Critical As Boolean = False
        Dim Warning As Boolean = False

        For Each obj In mos.Get()
            If res_str <> "" Then res_str = res_str & "<br>"
            If Not IsNothing(obj("LoadPercentage")) Then
                Select Case (CInt(obj("LoadPercentage").ToString))
                    Case Is > CInt(critical_val)
                        Critical = True
                        res_str = res_str & "<b>" & obj("DeviceID") & " Load: " & obj("LoadPercentage").ToString & "%</b>"
                    Case Is > CInt(warning_val)
                        Warning = True
                        res_str = res_str & obj("DeviceID") & " Load: " & obj("LoadPercentage").ToString & "%"
                    Case Else
                        res_str = res_str & obj("DeviceID") & " Load: " & obj("LoadPercentage").ToString & "%"
                End Select
            Else
                ' returned null value
                res_str = res_str & obj("DeviceID") & " Load: WMI returned null<br>"
            End If
        Next

        If Critical Then
            Return wsc_version & "Result: CPU(s) Critical<br>" + res_str
        ElseIf Warning Then
            Return wsc_version & "Result: CPU(s) Warning<br>" + res_str
        Else
            Return wsc_version & "Result: CPU(s) Okay<br>" + res_str
        End If
    End Function

    <WebMethod(Description:="This method acts like a wmi proxy")> Public Function generic_WMI(ByVal server As String, ByVal WMI_Class As String, ByVal Select_Fields As String, ByVal Where_clause As String) As Xml.XmlDocument

        ' parameters:
        ' server = name of remote server to query
        ' WMI_Class = Which WMI_Class to parse
        ' 
        Dim in_WMI_Fields As String = Select_Fields
        If in_WMI_Fields = "" Then in_WMI_Fields = "*"
        Dim in_WMI_Class As String = WMI_Class
        If in_WMI_Class = "" Then in_WMI_Class = "Win32_LogicalDisk"
        Dim in_where As String = Where_clause

        Dim select_sql As String = "SELECT " + in_WMI_Fields + " FROM " + in_WMI_Class
        If in_where <> "" Then
            select_sql = select_sql + " WHERE " + in_where
        End If
        get_auth(server, username, password)
        Dim strComputer As String = server
        Dim XMLdoc As New Xml.XmlDocument()
        Dim XMLRoot, NewNode, MemNode, Propnode
        Dim Prop
        Dim objSWbemLocator = CreateObject("WbemScripting.SWbemLocator")
        Dim objSWbemServices
        Dim Members

        If Not valid_caller() Then
            Return xml_error("Caller's IP address is not permitted access - " + Me.Context.Request.UserHostAddress, in_WMI_Class)
        End If
        If Not valid_call(in_WMI_Class) Then
            Return xml_error("WMI Class attempted is not currently permitted - " + in_WMI_Class, in_WMI_Class)
        End If
        Try
            objSWbemServices = objSWbemLocator.ConnectServer(strComputer, "root\cimv2", username, password)
            Members = objSWbemServices.ExecQuery(select_sql)
        Catch e As System.Runtime.InteropServices.COMException
            If Left(e.Message, 40) = "User credentials cannot be used for loca" Then
                '                     1234567890123456789012345678901234567890
                in_WMI_Fields = e.Message
                Members = Nothing
                objSWbemServices = Nothing
                objSWbemServices = GetObject("winmgmts:{impersonationLevel=impersonate}!\\" & server & "\root\cimv2")
                Members = objSWbemServices.ExecQuery(select_sql)
            Else
                'XMLdoc.LoadXml("<" & in_WMI_Class & "_Members/>")
                'XMLRoot = XMLdoc.SelectSingleNode(in_WMI_Class & "_Members")
                'NewNode = XMLdoc.CreateElement(in_WMI_Class)
                'MemNode = XMLRoot.AppendChild(NewNode)
                'NewNode = XMLdoc.CreateElement("Error")
                'Propnode = MemNode.AppendChild(NewNode)
                'Propnode.SetAttribute("Value", e.Message)
                Return xml_error(e.Message, in_WMI_Class)
            End If
        End Try
        Dim Member

        Dim res_str As String = ""

        XMLdoc.LoadXml("<" & in_WMI_Class & "_Members/>")
        XMLRoot = XMLdoc.SelectSingleNode(in_WMI_Class & "_Members")

        For Each Member In Members

            NewNode = XMLdoc.CreateElement(in_WMI_Class)
            MemNode = XMLRoot.AppendChild(NewNode)
            For Each Prop In Member.Properties_
                NewNode = XMLdoc.CreateElement(Prop.Name)
                If Not IsNothing(Prop.Value) Then
                    Propnode = MemNode.AppendChild(NewNode)
                    If IsArray(Prop.Value) Then
                        Propnode.SetAttribute("Value", Join(Prop.Value, ",") & ")")
                    Else
                        Propnode.SetAttribute("Value", Prop.Value.ToString)
                    End If
                End If
            Next
        Next
        'res_str = XMLdoc
        Return XMLdoc

    End Function

    Private Function xml_error(ByVal in_message As String, ByVal in_class As String) As Xml.XmlDocument
        Dim xmldoc As New Xml.XmlDocument()
        Dim XMLRoot, NewNode, MemNode, Propnode

        xmldoc.LoadXml("<" & in_class & "_Members/>")
        XMLRoot = xmldoc.SelectSingleNode(in_class & "_Members")
        NewNode = xmldoc.CreateElement(in_class)
        MemNode = XMLRoot.AppendChild(NewNode)
        NewNode = xmldoc.CreateElement("Error")
        Propnode = MemNode.AppendChild(NewNode)
        Propnode.SetAttribute("Value", in_message)
        Return xmldoc
    End Function

    Private Function valid_caller() As Boolean

        Dim caller_ip As String = Me.Context.Request.UserHostAddress
        Dim ret_val As Boolean = False


        Dim ip_list As String = System.Configuration.ConfigurationSettings.AppSettings("valid_callers")
        Dim valid_ip_arr() As String = ip_list.Split(",")
        ' should now have an array of valid caller IP addresses
        Dim i As Integer
        For i = 0 To valid_ip_arr.GetUpperBound(0)
            If caller_ip = valid_ip_arr(i) Then
                'caller allowed
                ret_val = True
            End If
        Next

        caller_ip = Nothing
        ip_list = Nothing
        valid_ip_arr = Nothing
        Return ret_val

    End Function
    Private Function valid_call(ByVal in_call As String) As Boolean

        Dim ret_val As Boolean = False

        Dim call_list As String = System.Configuration.ConfigurationSettings.AppSettings("valid_calls")
        Dim valid_call_arr() As String = call_list.Split(",")
        ' should now have an array of valid calls we can make
        Dim i As Integer
        For i = 0 To valid_call_arr.GetUpperBound(0)
            If in_call.ToLower = valid_call_arr(i).ToLower Then
                'call allowed
                ret_val = True
            End If
        Next

        call_list = Nothing
        valid_call_arr = Nothing
        Return ret_val

    End Function
    Private Sub get_auth(ByVal server As String, ByRef username As String, ByRef password As String)
        Dim a, b As String
        Dim i As Integer

        'look for auth string for current server
        Dim auth_string As String = System.Configuration.ConfigurationSettings.AppSettings(server)
        If auth_string = "" Then
            ' no alternative password defined, fall back to default
            a = System.Configuration.ConfigurationSettings.AppSettings("sysusername")
            b = System.Configuration.ConfigurationSettings.AppSettings("syspassword")
        Else
            'slice up whatever's returned
            i = InStr(auth_string, ":")
            a = Left(auth_string, i - 1)
            b = Mid(auth_string, i + 1)
        End If

        username = a
        password = b

    End Sub

    Private Function get_gb(ByVal invalue As Double) As String
        Return Format((invalue / (1024L * 1024L * 1024L)), "standard") & "GB"
    End Function

    Private Function WMIDateStringToDate(ByVal dtmBootup)
        WMIDateStringToDate = CDate(Microsoft.VisualBasic.Left(dtmBootup, 4) & "/" & _
             Mid(dtmBootup, 5, 2) & "/" & _
             Mid(dtmBootup, 7, 2) & _
             " " & Mid(dtmBootup, 9, 2) & ":" & _
             Mid(dtmBootup, 11, 2) & ":" & Mid(dtmBootup, _
             13, 2))
    End Function
    Private Function check_debug(ByVal server As String) As String

        If LCase(Left(server, 6)) = "debug*" Then
            debug_flag = True
            Return Mid(server, 7)
        Else
            Return server
        End If


    End Function


End Class
